//+------------------------------------------------------------------+
//|                                     Indicator: BusinextArrow.mq4 |
//|                                      Businext Trading Grpup 2020 |
//|                                         https://www.Businext.Org |
//+------------------------------------------------------------------+
#property copyright "Businext Trading Grpup 2020"
#property link      "https://Businext.Org"
#property version   "1.00"
#property description ""

#include <stdlib.mqh>
#include <stderror.mqh>

//--- indicator settings --- //
#property indicator_chart_window
#property indicator_buffers 2

#property indicator_type1 DRAW_ARROW
#property indicator_width1 2
#property indicator_color1 clrDodgerBlue
#property indicator_label1 "Buy"

#property indicator_type2 DRAW_ARROW
#property indicator_width2 2
#property indicator_color2 clrRed
#property indicator_label2 "Sell"

//--- indicator buffers
double Buffer1[];
double Buffer2[];

extern int MomPeriod = 14;
double myPoint; //initialized in OnInit

void myAlert(string type, string message)
  {
   if(type == "print")
      Print(message);
   else if(type == "error")
     {
      Print(type+" | BusinextArrow @ "+Symbol()+","+IntegerToString(Period())+" | "+message);
     }
   else if(type == "order")
     {
     }
   else if(type == "modify")
     {
     }
  }

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {   
   IndicatorBuffers(2);
   SetIndexBuffer(0, Buffer1);
   SetIndexEmptyValue(0, EMPTY_VALUE);
   SetIndexArrow(0, 233);
   SetIndexBuffer(1, Buffer2);
   SetIndexEmptyValue(1, EMPTY_VALUE);
   SetIndexArrow(1, 234);
   //initialize myPoint
   myPoint = Point();
   if(Digits() == 5 || Digits() == 3)
     {
      myPoint *= 10;
     }
   return(INIT_SUCCEEDED);
  }

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime& time[],
                const double& open[],
                const double& high[],
                const double& low[],
                const double& close[],
                const long& tick_volume[],
                const long& volume[],
                const int& spread[])
  {
   int limit = rates_total - prev_calculated;
   //--- counting from 0 to rates_total
   ArraySetAsSeries(Buffer1, true);
   ArraySetAsSeries(Buffer2, true);
   //--- initial zero
   if(prev_calculated < 1)
     {
      ArrayInitialize(Buffer1, 0);
      ArrayInitialize(Buffer2, 0);
     }
   else
      limit++;
   
   //--- main loop
   for(int i = limit-1; i >= 0; i--)
     {
      if (i >= MathMin(5000-1, rates_total-1-50)) continue; //omit some old rates to prevent "Array out of range" or slow calculation   
      
      //Indicator Buffer 1
      if(iCustom(NULL, PERIOD_CURRENT, "Aroon", MomPeriod, 0, i) > iCustom(NULL, PERIOD_CURRENT, "Aroon", MomPeriod, 1, i)
      && iCustom(NULL, PERIOD_CURRENT, "Aroon", MomPeriod, 0, i+1) < iCustom(NULL, PERIOD_CURRENT, "Aroon", MomPeriod, 1, i+1) //Aroon crosses above Aroon
      )
        {
         Buffer1[i] = Low[i] - 3 * myPoint; //Set indicator value at Candlestick Low - fixed value
        }
      else
        {
         Buffer1[i] = EMPTY_VALUE;
        }
      //Indicator Buffer 2
      if(iCustom(NULL, PERIOD_CURRENT, "Aroon", MomPeriod, 0, i) < iCustom(NULL, PERIOD_CURRENT, "Aroon", MomPeriod, 1, i)
      && iCustom(NULL, PERIOD_CURRENT, "Aroon", MomPeriod, 0, i+1) > iCustom(NULL, PERIOD_CURRENT, "Aroon", MomPeriod, 1, i+1) //Aroon crosses below Aroon
      )
        {
         Buffer2[i] = High[i] + 3 * myPoint; //Set indicator value at Candlestick High + fixed value
        }
      else
        {
         Buffer2[i] = EMPTY_VALUE;
        }
     }
   return(rates_total);
  }
//+------------------------------------------------------------------+